=== jbmc/CMakeLists.txt ===
add_subdirectory(regression)
add_subdirectory(src)
add_subdirectory(unit)
