=== debian/changelog ===
cbmc (5.9-6) unstable; urgency=low

  * Fix mips 32-bit cross configuration
  * Fix Java string literal conversion for big-endian architectures

 -- Michael Tautschnig <mt@debian.org>  Thu, 05 Jul 2018 22:36:05 +0100

cbmc (5.9-5) unstable; urgency=low

  * Add support for goto-gcc on kfreebsd
  * Fix regression test for unsigned-char architectures

 -- Michael Tautschnig <mt@debian.org>  Wed, 04 Jul 2018 16:50:58 +0100

cbmc (5.9-4) unstable; urgency=low

  * Fix preprocessing flags for non-x86 architectures
  * Fix copy&paste error in built-in library
  * Fix endianness bugs in tests
  * Enable all hardening flags

 -- Michael Tautschnig <mt@debian.org>  Wed, 04 Jul 2018 10:53:33 +0100

cbmc (5.9-3) unstable; urgency=low

  * Make bitwidth preprocessor options architecture-specific

 -- Michael Tautschnig <mt@debian.org>  Tue, 03 Jul 2018 18:58:45 +0100

cbmc (5.9-2) unstable; urgency=low

  * Build-depends libc6-dev-i386 for amd64, x32

 -- Michael Tautschnig <mt@debian.org>  Tue, 03 Jul 2018 16:17:02 +0100

cbmc (5.9-1) unstable; urgency=low

  * New upstream release
    - Fixes FTBFS with new GCC due to uninitialized variables (Closes: #871068)

 -- Michael Tautschnig <mt@debian.org>  Mon, 02 Jul 2018 17:12:01 +0100
