=== debian/control ===
Source: cbmc
Section: science
Priority: optional
Maintainer: Michael Tautschnig <mt@debian.org>
Build-Depends: debhelper (>= 10), minisat (>= 1:2.2.1-2), zlib1g-dev, flex,
 bison, openjdk-8-jdk-headless
Standards-Version: 4.1.5
Homepage: http://www.cprover.org/cbmc/

Package: cbmc
Architecture: any
Depends: gcc, ${shlibs:Depends}, ${misc:Depends}
Description: bounded model checker for C and C++ programs
 CBMC generates traces that demonstrate how an assertion can be violated, or
 proves that the assertion cannot be violated within a given number of loop
 iterations.
