=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND := -Wall -O2 -g -Werror -Wno-parentheses -Wno-deprecated -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) -C src clean
	$(RM) src/goto-cc/goto-gcc
	$(MAKE) -C jbmc/src clean
	$(RM) -r jbmc/src/java_bytecode/library/src
	$(MAKE) -C regression clean
	$(MAKE) -C jbmc/regression clean
	$(RM) regression/cbmc/Malloc22/main.smt2
	$(RM) regression/goto-gcc/run_diagnostic/a.out.goto-cc-saved
	$(RM) regression/goto-gcc/expect_fail/a.out.goto-cc-saved
	$(RM) regression/invariants/driver
	$(RM) regression/invariants/tests.log
	$(RM) regression/invariants/invariant-failure*/test.out
	$(RM) jbmc/regression/jbmc-strings/tests-symex-driven-loading.log
	$(RM) jbmc/regression/jbmc/tests-symex-driven-loading.log

override_dh_auto_configure:
	cp -r java-models-library/src jbmc/src/java_bytecode/library

override_dh_auto_build:
	$(MAKE) -C src \
		MINISAT2=/usr/include/minisat \
		LINKFLAGS=$(shell dpkg-buildflags --get LDFLAGS) \
		LIBSOLVER=-lminisat GIT_INFO=cbmc-5.9
	$(MAKE) -C jbmc/src \
		MINISAT2=/usr/include/minisat \
		LINKFLAGS=$(shell dpkg-buildflags --get LDFLAGS) \
		LIBSOLVER=-lminisat GIT_INFO=cbmc-5.9

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C regression test
	$(MAKE) -C jbmc/regression test
endif
