=== unit/Makefile ===
--- 
+++ 
@@ -7,13 +7,17 @@
 
 # Test source files
 SRC += unit_tests.cpp \
+       analyses/ai/ai.cpp \
        analyses/ai/ai_simplify_lhs.cpp \
        analyses/call_graph.cpp \
+       analyses/constant_propagator.cpp \
+       analyses/disconnect_unreachable_nodes_in_graph.cpp \
        analyses/does_remove_const/does_expr_lose_const.cpp \
        analyses/does_remove_const/does_type_preserve_const_correctness.cpp \
        analyses/does_remove_const/is_type_at_least_as_const_as.cpp \
        goto-programs/goto_trace_output.cpp \
        path_strategies.cpp \
+       solvers/floatbv/float_utils.cpp \
        solvers/refinement/array_pool/array_pool.cpp \
        solvers/refinement/string_constraint_generator_valueof/calculate_max_string_length.cpp \
        solvers/refinement/string_constraint_generator_valueof/get_numeric_value_from_character.cpp \
@@ -22,7 +26,11 @@
        solvers/refinement/string_refinement/substitute_array_list.cpp \
        solvers/refinement/string_refinement/sparse_array.cpp \
        solvers/refinement/string_refinement/union_find_replace.cpp \
+       util/expr.cpp \
        util/expr_cast/expr_cast.cpp \
+       util/file_util.cpp \
+       util/get_base_name.cpp \
+       util/graph.cpp \
        util/irep.cpp \
        util/irep_sharing.cpp \
        util/message.cpp \
@@ -34,6 +42,7 @@
        util/string_utils/split_string.cpp \
        util/string_utils/strip_string.cpp \
        util/symbol_table.cpp \
+       util/unicode.cpp \
        catch_example.cpp \
        # Empty last line
