=== jbmc/regression/CMakeLists.txt ===
--- 
+++ 
@@ -11,3 +11,4 @@
 add_subdirectory(jbmc-concurrency)
 add_subdirectory(jbmc-inheritance)
 add_subdirectory(jbmc-cover)
+add_subdirectory(jbmc-generics)
