=== debian/changelog ===
cbmc (5.10-5ubuntu1) focal; urgency=medium

  [ Adrian Bunk ]
  * Build fixes:
    - Fix the build with libmaven-compiler-plugin-java 3.8.1.
    - Backport upstream fix for building with new bison.
    (Closes: #952256)

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 14 Apr 2020 07:35:50 +0000

cbmc (5.10-5build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:11:11 +0100

cbmc (5.10-5) unstable; urgency=low

  * Use default-jdk-headless instead of openjdk-8 (Closes: #910704)

 -- Michael Tautschnig <mt@debian.org>  Wed, 17 Oct 2018 19:55:17 +0100

cbmc (5.10-4) unstable; urgency=low

  * Mark java_append_char test as THOROUGH as it requires more memory than
    available on some buildds.
  * Fix-up __float128 patch for ppc64 and powerpc.

 -- Michael Tautschnig <mt@debian.org>  Mon, 01 Oct 2018 08:00:38 +0100

cbmc (5.10-3) unstable; urgency=low

  * Fix regression tests using __float128, which is not available on all
    architectures.

 -- Michael Tautschnig <mt@debian.org>  Sun, 30 Sep 2018 18:29:38 +0100

cbmc (5.10-2) unstable; urgency=low

  * Fix regression tests using __float80, which is x86 only (Closes: #909932)

 -- Michael Tautschnig <mt@debian.org>  Sun, 30 Sep 2018 15:08:10 +0100

cbmc (5.10-1) unstable; urgency=low

  * New upstream release
  * Updated Standards version to 4.2.1 (no changes required)

 -- Michael Tautschnig <mt@debian.org>  Thu, 27 Sep 2018 10:18:47 +0100
