=== debian/control ===
--- 
+++ 
@@ -1,10 +1,13 @@
 Source: cbmc
 Section: science
 Priority: optional
-Maintainer: Michael Tautschnig <mt@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Michael Tautschnig <mt@debian.org>
 Build-Depends: debhelper (>= 10), minisat (>= 1:2.2.1-2), zlib1g-dev, flex,
- bison, openjdk-8-jdk-headless
-Standards-Version: 4.1.5
+ bison, default-jdk-headless, maven, maven-repo-helper, maven-debian-helper,
+ libmaven-compiler-plugin-java (>= 3.8.1),
+ libmaven-compiler-plugin-java (<< 3.8.2~)
+Standards-Version: 4.2.1
 Homepage: http://www.cprover.org/cbmc/
 
 Package: cbmc
