=== debian/rules ===
--- 
+++ 
@@ -21,30 +21,25 @@
 	$(MAKE) -C src clean
 	$(RM) src/goto-cc/goto-gcc
 	$(MAKE) -C jbmc/src clean
-	$(RM) -r jbmc/src/java_bytecode/library/src
+	$(RM) -r jbmc/lib
 	$(MAKE) -C regression clean
 	$(MAKE) -C jbmc/regression clean
-	$(RM) regression/cbmc/Malloc22/main.smt2
-	$(RM) regression/goto-gcc/run_diagnostic/a.out.goto-cc-saved
-	$(RM) regression/goto-gcc/expect_fail/a.out.goto-cc-saved
-	$(RM) regression/invariants/driver
-	$(RM) regression/invariants/tests.log
-	$(RM) regression/invariants/invariant-failure*/test.out
-	$(RM) jbmc/regression/jbmc-strings/tests-symex-driven-loading.log
-	$(RM) jbmc/regression/jbmc/tests-symex-driven-loading.log
+	$(RM) jbmc/regression/jbmc-generics/tests-symex-driven-loading.log
+	$(RM) jbmc/regression/strings-smoke-tests/tests-symex-driven-loading.log
 
 override_dh_auto_configure:
-	cp -r java-models-library/src jbmc/src/java_bytecode/library
+	mkdir jbmc/lib
+	cp -r java-models-library jbmc/lib/
 
 override_dh_auto_build:
 	$(MAKE) -C src \
 		MINISAT2=/usr/include/minisat \
 		LINKFLAGS=$(shell dpkg-buildflags --get LDFLAGS) \
-		LIBSOLVER=-lminisat GIT_INFO=cbmc-5.9
+		LIBS=-lminisat GIT_INFO=cbmc-5.10
 	$(MAKE) -C jbmc/src \
 		MINISAT2=/usr/include/minisat \
 		LINKFLAGS=$(shell dpkg-buildflags --get LDFLAGS) \
-		LIBSOLVER=-lminisat GIT_INFO=cbmc-5.9
+		LIBS=-lminisat GIT_INFO=cbmc-5.10
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
